#!/usr/bin/ruby

#################################################################
#
# Copyright (c) 2008, Perforce Software, Inc.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1.  Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
# 2.  Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Description:
#
#   Split a Perforce server log into several files
#
# Usage:
#
#   logsplit.rb log_file
#
#################################################################

def croakusage
    puts("Usage: logsplit.rb log_file" )
    exit(0)
end

logfilename=ARGV[0]
if (logfilename=="")
  croakusage
end

re_starting = Regexp.new( '^\tPerforce Server starting (\d+/\d+/\d+ \d+:\d+:\d+)')
basename = File.basename(logfilename)
splitfile=File.open(basename+"_no_starting","w")
line = $<.gets
while line
    nextline = $<.gets
    if (match = re_starting.match(line) || match = re_starting.match(nextline))
	splitfile.close
	splitfile=File.open(basename+"_"+match[1].tr(' /','_'),"w")
    end
    splitfile.puts(line)
	#puts(line)
    line = nextline
end
splitfile.close
if File.stat(basename+"_no_starting").size==0 
   File.delete(basename+"_no_starting")
end
